#!/usr/bin/env Rscript

library(knitr, quietly  = TRUE)
library(markdown, quietly  = TRUE)
library(rjson, quietly =TRUE)
library(pander, quietly =TRUE)


# Generate tables for each file
for(DIR in dir("metadata", full.names = TRUE)){
	cat(paste("\n", DIR))	
	fname <- "site_description" 
	mdfile <- knit(paste0(fname, ".Rmd"), output = file.path(DIR, paste0(fname, ".md")))  # produces the md file		
	system(paste0("pandoc -V geometry:a4paper -V geometry:margin=1in ", mdfile, " -o ", file.path(DIR, paste0(fname, ".pdf"))))
}
